OVL     segment for 'code'
        assume cs:OVL, ds:OVL

org     100h                        ; output a .COM program

START:
mov     sp, 1024                    ; set stack pointer (size in bytes)
mov     bx, 1024/16                 ; set bx=bytes/16, es=mem segment
mov     ah, 4ah                     ; change memory allocation
int     21h                         ; commit

mov     ax, 3521h                   ; get OLDINT
int     21h                         ; commit

mov     OLDINT[0], bx               ; safe OLDINT to call later
mov     OLDINT[2], es               ; ?? no idea ?? 

mov     ax, 2521h                   ; set NEWINT
lea     dx, NEWINT                  ; with pointer to NEWINT proc far routine
int     21h

lea     bx, EXEC_INFO               ; ?? no idea ??
lea     dx, FILENAME                ; pointer to FILENAME
mov     ax, 4b00h                   ; load and run FILENAME
int     21h                         ; commit

mov     ax, 4c00h                   ; ah=exit, al=errorlevel
int     21h                         ; commit

OLDINT  dw 0,0                      ; original INT

NEWINT  proc far
pushf                               ; safe flags
cmp     dx, 029DAh                  ; compare if INT is called with X
jnz     EXIT                        ; yes: goto CHECK, no: goto OLDINT

CHECK:
push    bp                          ; safe 'bp'
mov     bp, sp                      ; 'bp' points to top of the stack
push    es                          ; safe 'es'
mov     es, [bp]                    ; copy bp to 'es'
cmp     word ptr es:[0XXXX], 0XXXXh ; if data matches search query
jne     RESTORE                     ; yes: goto PATCH , no: goto RESTORE

PATCH:                              ; --------------- patch -------------------
mov     byte ptr es:[0XXXX], 0XXh   ; change byte offset es:xxxx to xxxh
                                    ; ------------- end patch -----------------
    
RESTORE:
pop     es                          ; restore 'es'
pop     bp                          ; restore 'bp'

EXIT:
popf                                ; restore flags
jmp     dword ptr cs:[OLDINT]       ; jump to OLDINT

NEWINT endp

FILENAME    db "GAME.EXE",0   	    ; program to execute
EXEC_INFO   db 22 DUP (0)           ; ?? no idea : 22x 00h for what ??

OVL ends
end START

